#include <comunicacion rs232 valores esclavo.h>

#include "string.h"
#include "stdlib.h"

#FUSES NOMCLR

#use i2c(Master, Fast, sda=PIN_B0, scl=PIN_B1, force_sw, stream=OLED_stream)//parametros I2C
#use rs232(baud=9600, parity=N, xmit=PIN_C6, rcv=PIN_C7, bits=8)


#define SH1106_128_64 //DEFINE EL MODELO DE LA PANTALLA OLED
//#define SSD1306_128_64

#include "OLED_I2C.c" //libreria oled I2C


char recibido[20];
int16 POT_1;
int16 POT_2;

void datos();
void mostrar();


#int_rda
void rda_isr()
{
   memset(recibido, 0, sizeof(recibido)); //limpia los registros de la varible
   int8 i=0;
   while(true)
   {
      recibido[i]=getc();//RECIBE EL CARACTER

      if(recibido[i]=='\r')//busca el salto de linea \r
      {
         recibido[i]='\0';//fin de la cadena = caracter nulo \0
         datos();
         mostrar();
         return;
      }
      i++;
   }
}


void datos()
{
   signed int8 result;

   char POT[10];
   char num[10];

   char POT1[10] = "POT1";
   char POT2[10] = "POT2";

   memset(POT, 0, sizeof(POT)); //limpia los registros de la varible POT
   memset(num, 0, sizeof(num)); //limpia los registros de la varible num

   while (true)
   {
       for (int i=0; i<=3; ++i)
      {
         POT[i] = recibido[i]; //identifica el potennciometro
      }

      for (int i=0; i<=3; ++i)
      {
         num[i] = recibido[i+4]; //guarda el valor del potennciometro
      }

      result = strcmp(POT, POT1);//compara, si son iguales (0), no (+-1)

      if(result==0)
      {
         POT_1 = (int16)atol(num);  //convierte la cadena en un numero de 16bits
         return;
      }

      result = strcmp(POT, POT2);

      if(result==0)
      {
         POT_2 = (int16)atol(num); //convierte la cadena en un numero de 16bits
         return;
      }

      return;
   }
}


void mostrar()
{
   char texto[20];

   sprintf(texto,"POT1=%04lu",POT_1);
   OLED_DrawText(1,1,texto,1);

   sprintf(texto,"POT2=%04lu",POT_2);
   OLED_DrawText(1,10,texto,1);

   OLED_Display();//Muestra la informacin en pantalla;
}


void main()
{
   enable_interrupts(int_rda);
   enable_interrupts(global);

   OLED_Begin();
   OLED_ClearDisplay();

   while(TRUE)
   {


      //TODO: User Code
   }
   
}
